searchNodes=[{"type":"protocol","title":"ExCop.Policy.Protocol","doc":"","ref":"ExCop.Policy.Protocol.html"},{"type":"function","title":"ExCop.Policy.Protocol.before/6","doc":"","ref":"ExCop.Policy.Protocol.html#before/6"},{"type":"function","title":"ExCop.Policy.Protocol.can?/6","doc":"","ref":"ExCop.Policy.Protocol.html#can?/6"},{"type":"type","title":"ExCop.Policy.Protocol.args/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:args/0"},{"type":"type","title":"ExCop.Policy.Protocol.context/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:context/0"},{"type":"type","title":"ExCop.Policy.Protocol.error_response/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:error_response/0"},{"type":"type","title":"ExCop.Policy.Protocol.everything/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:everything/0"},{"type":"type","title":"ExCop.Policy.Protocol.field/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:field/0"},{"type":"type","title":"ExCop.Policy.Protocol.parent/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:parent/0"},{"type":"type","title":"ExCop.Policy.Protocol.response/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:response/0"},{"type":"type","title":"ExCop.Policy.Protocol.t/0","doc":"All the types that implement this protocol.","ref":"ExCop.Policy.Protocol.html#t:t/0"},{"type":"type","title":"ExCop.Policy.Protocol.user/0","doc":"","ref":"ExCop.Policy.Protocol.html#t:user/0"},{"type":"extras","title":"ExCop","doc":"ExCopExCop is a flexible policy DSL allowing you to write easy-to-navigate policies. ExCop doesn't make any assumption about what kind of layer is on top or under it - and even though it was designed to work particularily easily with Absinthe, it should also work for many other environments.","ref":"readme.html"},{"type":"extras","title":"ExCop - Installation","doc":"If available in Hex, the package can be installed by adding ex_cop to your list of dependencies in mix.exs:def deps do [ {:ex_cop, &quot;~&gt; 0.1.0&quot;} ] endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/ex_cop.","ref":"readme.html#installation"},{"type":"extras","title":"ExCop - Configuration","doc":"Once installed, you must tell ExCop which one is your user module. You do that in your configuration by adding something like:config :ex_cop, user_module: MyApp.User","ref":"readme.html#configuration"},{"type":"extras","title":"ExCop - Policy System","doc":"To write a policy, simply create a module looking like something like the following:defmodule MyApp.PostPolicy do alias MyApp.{Post, User} use ExCop, target: Post allowance &quot;all users can see a post title and body if it&#39;s valid&quot; do # We require that the `%Post{}` subject has a field `valid` set to `true`. subject %{valid: true} field_in [:title, :body] end allowance &quot;logged-in users can see the author of a post&quot; do requires_logged_in_user() field :author end allowance &quot;users can see everything on posts they authored&quot; do subject %{author_id: user_id} user %User{id: user_id} end allowance &quot;posts with less than three comments can be seen by logged-in users&quot; do # Here, we guard against the shape of a particular subject, and later use that binding. subject %{comment_count: count} # This is a shortcut to `user %User{}`. requires_logged_in_user() guard count &lt; 3 end allowance &quot;allows CIA users to see everything on posts for area 51&quot; do subject %{cia_post: true, mission: mission} check do String.downcase(user.agency) == &quot;cia&quot; &amp;&amp; mission =~ &quot;area 51&quot; end end allowance &quot;administrators can see everything in a post&quot; do # This is a shortcut to `user %User{is_admin: true}`. requires_admin_user() end endIf you're using Absinthe and want to control what is happening at the root of your schema, you'll have to implement a policy such as this one:defmodule MyApp.RootPolicy do @moduledoc false use ExCop.Policy, target: Map # Shortcut to using `parent :query`. query_allowance &quot;users can access certain queries&quot; do requires_logged_in_user() field_in [:me, :users, :onboards, :documents] end # Shortcut to using `parent :mutation`. mutation_allowance &quot;guests can create new users and authenticate&quot; do requires_guest_user() field_in [:create_user, :authenticate] end end","ref":"readme.html#policy-system"},{"type":"extras","title":"ExCop - Policy Delegation to Another Policy","doc":"Another trick you can leverage while using ExCop is the policy delegation feature. Consider something like the following:defmodule MyApp.RootPolicy do @moduledoc false use ExCop.Policy, target: Map # Shortcut to using `parent :query`. mutation_allowance &quot;users can access certain queries&quot; do field :add_comment delegated() end endThis particular policy would destructure the context into %{fetched: %{subject: subject}} and call ExCop.Policy.Protocol.can?/6, effectivelly replacing the subject by the one found in context. Therefore, if the subject is of a different type, the protocol would in turn try to find a matching policy for the new subject.Note that for this mechanism to work, you will need to have the context fetched before you try and apply policies to your subject. See the &quot;Loading Subjects&quot; paragraph for more information.","ref":"readme.html#policy-delegation-to-another-policy"},{"type":"extras","title":"ExCop - Advices","doc":"Policies are compiled into Elixir. A module will be created conforming to the ExCop.Policy and declaring a series of can?/6 functions, one per policy you called.At runtime, policies are evaluated from top to bottom - so it might be a good idea to keep the most used ones on top and the most expensive ones to run at the bottom, like you would usually do with pattern-matching.In case of a default:If no policy module exists for the target, it will return {:error, :missing_policy}.When no policy is found matching the arguments, {:error, :unauthorized} will be returned.Note that most of the builder is defined using macros - so you will get compile-time errors and warnings if you define a guard using a variable that is unknown, or if you declare a binding that is not used.For more informations about how policies can be written, please check test/ex_cop/police_test.exs and its fixtures.","ref":"readme.html#advices"},{"type":"extras","title":"ExCop - The check/0 Function","doc":"If you decide to use the check function, be mindful of the following:You can use the following bindings subject, user, parent, field, context and args.Your check block will allow access if it returns anything else than false-ey.The check function is performed after pattern matching - meaning that once the check block is entered, no further policy will be evaluated, even if the check block returns false-ey.","ref":"readme.html#the-check-0-function"},{"type":"extras","title":"ExCop - Manually Verifying Policies","doc":"To check for a policy, you can do something like this:source |&gt; ExCop.Police.check(user, parent, field, context, args)","ref":"readme.html#manually-verifying-policies"},{"type":"extras","title":"ExCop - Loading Subjects","doc":"For certain policies, you want to make sure that the subject is loaded before the policies are ran. In the case of Absinthe, it means that you might want to have your subject loaded before your authorization layer kicks-in.","ref":"readme.html#loading-subjects"}]